#include <bits/stdc++.h>

/*
#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("bmi, avx2")
*/
#define endl '\n'

using namespace std;

const int MAXN = 1e6 + 50;
int a[MAXN];

struct SegmentTree
{
    int64_t n, tree[MAXN*4];
    SegmentTree(int n)
        :n(n){}

    void Recalculate(int node)
    {
        tree[node] = tree[node*2] + tree[node*2+1];
    }

    void Build()
    {
        BuildInternal(1, 1, n);
    }

    void BuildInternal(int node, int l, int r)
    {
        if (l == r)
        {
            tree[node] = 0;
            return;
        }

        BuildInternal(node*2, l, (l+r)/2);
        BuildInternal(node*2+1, (l+r)/2+1, r);

        Recalculate(node);

    }

    void UpdateInternal(int node, int l, int r, int q, int64_t change)
    {
        if (r < q || l > q)
            return;

        if (l == q && l == r)
        {
            //cout << l << " " << change << " 0000 " << tree[node] << endl;
            tree[node] += change;
            return;
        }

        UpdateInternal(node*2, l, (l+r)/2, q, change);
        UpdateInternal(node*2+1, (l+r)/2+1, r, q, change);

        Recalculate(node);
    }

    void Update(int q, int64_t change)
    {
        UpdateInternal(1, 1, n, q, change);
    }

    int QueryInternal(int node, int ql, int qr, int l, int r)
    {
        if (l > qr || r < ql)
            return 0;

        if (ql <= l && r <= qr)
            return tree[node];

        return QueryInternal(node*2, ql, qr, l, (l+r)/2)
        + QueryInternal(node*2+1, ql, qr, (l+r)/2+1, r);
    }

    int Query(int ql, int qr)
    {
        return QueryInternal(1, ql, qr, 1, n);
    }
};

int parent[MAXN], n;
vector <int> child[MAXN];
int64_t ans = 0;

void DFS(int currNode, SegmentTree *tree)
{
    tree->Update(currNode, 1);

    for (int i:child[currNode])
        DFS(i, tree);

    tree->Update(currNode, -1);

    ans += tree->Query(currNode+1, n);
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    SegmentTree *tree = new SegmentTree(n);
    tree->Build();

    int root = 0;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        if (a[i] == 0)
            root = i;

        parent[i] = a[i];
        child[a[i]].push_back(i);
    }

    DFS(root, tree);
    cout << ans << endl;
    return 0;
}
