#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 1e3 + 1;
vector<int> neighbours[MAXN];
bool con[MAXN][MAXN];
void init(int N, vector< pair<int, int> > e) {
    for (auto it : e) {
        neighbours[it.first].push_back(it.second);
        neighbours[it.second].push_back(it.first);
        con[it.first][it.second] = true;
        con[it.second][it.first] = true;
    }
}
bool dfs(int curr, int prev, int target) {
    if (curr == target) {
        return true;
    }
    for (auto it : neighbours[curr]) {
        if (it != prev && con[curr][it]) {
            if (dfs(it, curr, target)) {
                return true;
            }
        }
    }
    return false;
}
bool question(int u, int v) {
    return dfs(u, 0, v);
}
void close(int u, int v) {
    con[u][v] = false;
    con[v][u] = false;
}
//int main () {
//    int n;
//    cin >> n;
//    for (int i = 1; i < n; i++) {
//        int a, b;
//        cin >> a >> b;
//        neighbours[a].push_back(b);
//        neighbours[b].push_back(a);
//        con[a][b] = true;
//        con[b][a] = true;
//    }
//    while (1) {
//        bool q;
//        int u, v;
//        cin >> u >> v >> q;
//        if (q) {
//            close(u, v);
//        } else {
//            cout << question(u, v);
//        }
//    }
//}
