#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 1e6 + 1;
bool stop[MAXN];
bool tree[MAXN * 4];
int ver;
void build(int curr, int from, int to) {
    if (from == to) {
        tree[curr] = stop[from];
    } else {
        build(curr * 2, from, (from + to) / 2);
        build(curr * 2 + 1, (from + to) / 2 + 1, to);
        tree[curr] = (tree[curr * 2] || tree[curr * 2 + 1]);
    }
}
bool query(int curr, int from, int to, int l, int r) {
    if (l <= from && to <= r) {
        return tree[curr];
    }
    if (l <= to && from <= r) {
        return (query(curr * 2, from, (from + to) / 2, l, r) || query(curr * 2 + 1, (from + to) / 2 + 1, to, l, r));
    }
    return false;
}
void update(int curr, int from, int to, int target) {
    if (from <= target && target <= to) {
        tree[curr] = true;
        if (from == to) {
            return;
        }
        update(curr * 2, from, (from + to) / 2, target);
        update(curr * 2 + 1, (from + to) / 2 + 1, to, target);
    }
}
void init(int N, vector< pair<int, int> > e) {
    ver = N;
    for (auto it : e) {
        stop[min(it.first, it.second)] = true;
    }
    for (int i = 1; i <= N; i++) {
        stop[i] = !stop[i];
    }
}
void close(int u, int v) {
    update(1, 1, ver, min(u, v));
}
bool question(int u, int v) {
    return !query(1, 1, ver, min(u, v), max(u, v) - 1);
}
