#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 1e6 + 1;
vector<int> neighbours[MAXN];
int depth[MAXN];
bool crossed[MAXN];
int fat[MAXN];
void dfs(int curr, int dep, int prev) {
    depth[curr] = dep;
    fat[curr] = prev;
    for (auto it : neighbours[curr]) {
        dfs(it, dep + 1, curr);
    }
}
int query(int curr, int root) {
    if (curr == root) {
        return crossed[curr];
    } else {
        return crossed[curr] + query(fat[curr], root);
    }
}
int main () {
    int n;
    cin >> n;
    int root;
    for (int i = 1; i <= n; i++) {
        int a;
        cin >> a;
        neighbours[a].push_back(i);
        if (a == 0) {
            root = i;
        }
    }
    depth[0] = -1;
    dfs(root, 0, 0);
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += depth[i] - query(i, root);
        crossed[i] = true;
    }
    cout << ans;
}

