#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 1e6 + 1;
vector<int> neighbours[MAXN];
int depth[MAXN];
bool crossed[MAXN];
int fat[MAXN];
bool done[MAXN];
int arr[MAXN];
int ind[MAXN];
int tree[MAXN * 4];
void build(int curr, int from, int to) {
    if (from == to) {
        tree[curr] = 1;
    } else {
        build(curr * 2, from, (from + to) / 2);
        build(curr * 2 + 1, (from + to) / 2 + 1, to);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }
}
int query(int curr, int from, int to, int r) {
    if (to <= r) {
        return tree[curr];
    }
    if (from <= r) {
        return (query(curr * 2, from, (from + to) / 2, r) + query(curr * 2 + 1, (from + to) / 2 + 1, to, r));
    }
    return 0;
}
void update(int curr, int from, int to, int target) {
    if (from <= target && target <= to) {
        tree[curr]--;
        if (from == to) {
            return;
        }
        update(curr * 2, from, (from + to) / 2, target);
        update(curr * 2 + 1, (from + to) / 2 + 1, to, target);
    }
}
void dfs(int curr, int dep, int prev) {
    depth[curr] = dep;
    fat[curr] = prev;
    for (auto it : neighbours[curr]) {
        dfs(it, dep + 1, curr);
    }
}
int query(int curr, int root) {
    if (curr == root) {
        return crossed[curr];
    } else {
        return crossed[curr] + query(fat[curr], root);
    }
}
int main () {
    int n;
    cin >> n;
    int root;
    bool stick = false;
    for (int i = 1; i <= n; i++) {
        int a;
        cin >> a;
        if (done[a]) {
            stick = false;
        }
        done[a] = true;
        neighbours[a].push_back(i);
        if (a == 0) {
            root = i;
        }
    }
    if (stick) {
        for (int i = 1; i <= n; i++) {
            arr[i] = root;
            root = neighbours[root][0];
        }
        for (int i = 1; i <= n; i++) {
            ind[arr[i]] = i;
        }
        build(1, 1, n);
        long long ans = 0;
        for (int i = 1; i <= n; i++) {
            ans += query(1, 1, n, ind[i] - 1);
            update(1, 1, n, ind[i]);
        }
        cout << ans;
        return 0;
    }
    depth[0] = -1;
    dfs(root, 0, 0);
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += depth[i] - query(i, root);
        crossed[i] = true;
    }
    cout << ans;
}

