#include <iostream>
#include <unordered_set>
#include <vector>

namespace {

bool contains(std::unordered_set<int> const& s, int x) {
	return s.find(x) != s.end();
}

struct bus_stop {
	std::unordered_set<int> connections;
};

std::vector<bus_stop> bus_stops;

void init(int stop_count, std::vector<std::pair<int, int>> routes) {
	bus_stops.resize(stop_count);
	for (auto [u, v] : routes) {
        u--;
        v--;
		bus_stops[u].connections.insert(v);
		bus_stops[v].connections.insert(u);
	}
}

void close(int u, int v) {
    u--;
    v--;
	bus_stops[u].connections.erase(v);
	bus_stops[v].connections.erase(u);
}

static bool q(std::unordered_set<int>& visited, int begin, int end) {
	if (begin == end)
		return true;
	for (int next : bus_stops[begin].connections) {
		if (!contains(visited, next)) {
			visited.insert(next);
			if (q(visited, next, end))
				return true;
		}
	}
	return false;
}

bool question(int begin, int end) {
    begin--;
    end--;
	std::unordered_set<int> visited;
	visited.insert(begin);
	return q(visited, begin, end);
}

};