#include <iostream>
#include <unordered_set>
#include <vector>
#include <limits.h>

/*
    distance = 5
    initial distance = 1
    max price = 6

    pos t/km $/km
    1   1    1
    2   2    2
    3   3    3
    4   2    1

4 5 1 6
1 1 1
2 2 2
3 3 3
4 2 1
*/

struct station {
    int pos;
    int time_per_km;
    int price_per_km;
};

int main() {
    int station_count, target_distance, initial_available_distance, max_price;
    std::cin >> station_count >> target_distance >> initial_available_distance >> max_price;

    std::vector<station> stations(station_count);
    for (auto& s : stations)
        std::cin >> s.pos >> s.time_per_km >> s.price_per_km;

    int best_price = INT_MAX;
    int best_max_time = INT_MAX;
    std::vector<bool> used_stations(station_count);
    for (int i = 0; i < (1 << station_count); i++) {
        int price = 0;
        int max_time = 0;
        std::vector<station> used;
        for (int j = 0; j < station_count; j++)
            if (used_stations[j])
                used.push_back(stations[j]);
        int pos = i ? used[0].pos : target_distance;
        int available_distance = initial_available_distance - pos;
        if (available_distance >= 0) {
            for (size_t j = 0; j < used.size(); j++) {
                int next_pos = j + 1 == used.size() ? target_distance : used[j + 1].pos;
                int distance_to_next = next_pos - pos;
                if (available_distance < distance_to_next) {
                    // have to charge
                    int added_distance = distance_to_next - available_distance;
                    price += added_distance * used[j].price_per_km;
                    if (price > max_price) {
                        goto l;
                    }
                    max_time = std::max(max_time, added_distance * stations[j].time_per_km);
                    if (max_time > best_max_time) {
                        goto l;
                    }
                }
                available_distance -= distance_to_next;
                pos = next_pos;
            }
            if (max_time == best_max_time)
                best_price = std::min(best_price, price);
            else
                best_price = price;
            best_max_time = max_time;
        }
    l:

        bool c = 1;
        for (int j = 0; j < station_count && c; j++) {
            c = used_stations[j];
            used_stations[j] = !used_stations[j];
        }
    }

    std::cout << best_max_time << ' ' << best_price;

    return 0;
}

