#include<iostream>
#include<queue>
using namespace std;
const int MAX_N=1e5+5;
const int LOG=21;
int tree[4*MAX_N];
int in[MAX_N];
int sz[MAX_N];
int n;
vector<int>g[MAX_N];
int d[MAX_N];
vector<int>tour;
int T;
int par[MAX_N][LOG+1];
void DFS(int u,int pare)
{
    in[u]=++T;
    sz[u]=1;
    for(int v:g[u])
    {
        if(v==pare)continue;
        d[v]=d[u]+1;
        par[v][0]=u;
        DFS(v,u);
        sz[u]+=sz[v];
    }
}
int LCA(int u,int v)
{
    if(d[u]<d[v])swap(u,v);
    for(int j=LOG-1;j>=0;j--)
    {
        if(d[u]-(1<<j)>=d[v])
        {
            u=par[u][j];
        }
    }
    if(u==v)return u;
    for(int j=LOG-1;j>=0;j--)
    {
        if(par[u][j]!=par[v][j])
        {
            u=par[u][j];
            v=par[v][j];
        }
    }
    return par[u][0];
}
void precompute()
{
    DFS(1,0);
    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=n;i++)
        {
            par[i][j]=par[par[i][j-1]][j-1];
        }
    }
}
void init (int N, std::vector< std::pair<int,int> > e)
{
    n=N;
    for(auto [u,v]:e)
    {
        g[u].push_back(v);
        g[v].push_back(u);
    }
    precompute();
}
void Update(int node,int l,int r,int ql,int qr,int x)
{
    if(ql<=l && r<=qr)
    {
        tree[node]=max(tree[node],x);
        return;
    }
    int mid=(l+r)/2;
    if(ql<=mid)Update(2*node,l,mid,ql,qr,x);
    if(mid<qr)Update(2*node+1,mid+1,r,ql,qr,x);
}
void close(int u,int v)
{
    if(d[u]<d[v])swap(u,v);
    Update(1,1,n,in[u],in[u]+sz[u]-1,d[u]);
}
int ans;
void Query(int node,int l,int r,int idx)
{
    ans=max(ans,tree[node]);
    if(l==r)return;
    int mid=(l+r)/2;
    if(idx<=mid)Query(2*node,l,mid,idx);
    else Query(2*node+1,mid+1,r,idx);
}
bool question(int u,int v)
{
    int lca=LCA(u,v);
    ans=0;
    Query(1,1,n,in[u]);
    if(d[lca]<ans)return 0;
    ans=0;
    Query(1,1,n,in[v]);
    if(ans!=1e9 && d[lca]<ans)return 0;
    return 1;
}

