#include<iostream>
#include<cmath>
#include<queue>
using namespace std;
const int MAX_N=1e6+1;
const int LOG=21;
int tree[4*MAX_N];
int in[MAX_N];
int sz[MAX_N];
int n;
vector<int>g[MAX_N];
int d[MAX_N];
vector<int>tour;
int T;
int a[MAX_N];
int block[2000];
int par[MAX_N][LOG+1];
int s;
void DFS(int u,int pare)
{
    in[u]=++T;
    sz[u]=1;
    for(int v:g[u])
    {
        if(v==pare)continue;
        d[v]=d[u]+1;
        par[v][0]=u;
        DFS(v,u);
        sz[u]+=sz[v];
    }
}
int LCA(int u,int v)
{
    if(d[u]<d[v])swap(u,v);
    for(int j=LOG-1;j>=0;j--)
    {
        if(d[u]-(1<<j)>=d[v])
        {
            u=par[u][j];
        }
    }
    if(u==v)return u;
    for(int j=LOG-1;j>=0;j--)
    {
        if(par[u][j]!=par[v][j])
        {
            u=par[u][j];
            v=par[v][j];
        }
    }
    return par[u][0];
}
void precompute()
{
    DFS(1,0);
    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=n;i++)
        {
            par[i][j]=par[par[i][j-1]][j-1];
        }
    }
}
void init (int N, std::vector< std::pair<int,int> > e)
{
    n=N;
    s=(int)sqrt(n);
    for(auto [u,v]:e)
    {
        g[u].push_back(v);
        g[v].push_back(u);
    }
    precompute();
}
void Update(int l,int r,int x)
{
    int bl=l/s;
    int br=r/s;
    if(bl==br)
    {
        for(int i=l;i<=r;i++)
        {
            a[i]=max(a[i],x);
        }
        return;
    }
    for(int i=l;i<(bl+1)*s;i++)
    {
        a[i]=max(a[i],x);
    }
    for(int i=bl+1;i<br;i++)
    {
        block[i]=max(block[i],x);
    }
    for(int i=br*s;i<=r;i++)
    {
        a[i]=max(a[i],x);
    }
}
void close(int u,int v)
{
    if(d[u]<d[v])swap(u,v);
    Update(in[u],in[u]+sz[u]-1,d[u]);
}
int ans;
int Query(int idx)
{
    return max(block[idx/s],a[idx]);
}
bool question(int u,int v)
{
    int lca=LCA(u,v);
    ans=Query(in[u]);
    if(d[lca]<ans)return 0;
    ans=Query(in[v]);
    if(d[lca]<ans)return 0;
    return 1;
}

