#include<iostream>
#include<cmath>
#include<queue>
using namespace std;
const int MAX_N=1e6+3;
const int LOG=23;
int in[MAX_N];
int sz[MAX_N];
int n;
vector<int>g[MAX_N];
int d[MAX_N];
vector<int>tour;
int T;
int a[MAX_N];
int block[2000];
int pos[MAX_N];
int s;
int lg[3000001];
int sp[3000001][LOG];
int wh[3000001][LOG];
void DFS(int u,int pare)
{
    in[u]=++T;
    tour.push_back(u);
    pos[u]=tour.size()-1;
    sz[u]=1;
    for(int v:g[u])
    {
        if(v==pare)continue;
        d[v]=d[u]+1;
        DFS(v,u);
        tour.push_back(u);
        sz[u]+=sz[v];
    }
}
void precompute()
{
    DFS(1,0);
    for(int i=1;i<=tour.size();i++)lg[i]=log2(i);
    for(int i=0;i<tour.size();i++)
    {
        sp[i][0]=d[tour[i]];
        wh[i][0]=tour[i];
    }
    for(int j=1;j<LOG;j++)
    {
        for(int i=0;i+(1<<(j))-1<tour.size();i++)
        {
            if(sp[i][j-1]<sp[i+(1<<(j-1))][j-1])
            {
                wh[i][j]=wh[i][j-1];
                sp[i][j]=sp[i][j-1];
            }
            else
            {
                wh[i][j]=wh[i+(1<<(j-1))][j-1];
                sp[i][j]=sp[i+(1<<(j-1))][j-1];
            }
        }
    }
}
int LCA(int i,int j)
{
    int k=lg[j-i+1];
    return (sp[i][k]<sp[j-(1<<k)+1][k] ? wh[i][k] : wh[j-(1<<k)+1][k]);
}
void init (int N, std::vector< std::pair<int,int> > e)
{
    n=N;
    s=(int)sqrt(n);
    for(auto [u,v]:e)
    {
        g[u].push_back(v);
        g[v].push_back(u);
    }
    precompute();
}
void Update(int l,int r,int x)
{
    int bl=l/s;
    int br=r/s;
    if(bl==br)
    {
        for(int i=l;i<=r;i++)
        {
            a[i]=max(a[i],x);
        }
        return;
    }
    for(int i=l;i<(bl+1)*s;i++)
    {
        a[i]=max(a[i],x);
    }
    for(int i=bl+1;i<br;i++)
    {
        block[i]=max(block[i],x);
    }
    for(int i=br*s;i<=r;i++)
    {
        a[i]=max(a[i],x);
    }
}
void close(int u,int v)
{
    if(d[u]<d[v])swap(u,v);
    Update(in[u],in[u]+sz[u]-1,d[u]);
}
int ans;
int Query(int idx)
{
    return max(block[idx/s],a[idx]);
}
bool question(int u,int v)
{
    int lca=LCA(min(pos[u],pos[v]),max(pos[u],pos[v]));
    //cout<<u<<" "<<v<<" "<<lca<<"\n";
    ans=Query(in[u]);
    if(d[lca]<ans)return 0;
    ans=Query(in[v]);
    if(d[lca]<ans)return 0;
    return 1;
}
